﻿using System;
using System.IO;
using System.Net;
using System.Text;
using System.Windows.Forms;

namespace _2ch {
    public partial class Form1 :Form {
        public Form1() {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e) {
            this.boardList1.LoadBoardList("http://menu.2ch.net/bbsmenu.html");
        }

        private void boardList1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e) {
            if(e.Button != MouseButtons.Left) return;
            Board board = e.Node.Tag as Board;
            if(board == null) return;
            this.threadList1.GetThreadList(board);
        }

        private void boardList1_KeyPress(object sender, KeyPressEventArgs e) {
            if(e.KeyChar != (char)(Keys.Enter)) return;
            boardList1_NodeMouseClick(sender, new TreeNodeMouseClickEventArgs(this.boardList1.SelectedNode, MouseButtons.Left, 1, 0, 0));
            e.Handled = true;
        }

        private void threadList1_Click(object sender, EventArgs e) {
            Thread thread = this.threadList1.SelectedItem as Thread;
            if(thread == null) return;
            string url = this.threadList1.Board.Url + "dat/" + thread.Number;

            HttpWebRequest hwreq = (HttpWebRequest)(HttpWebRequest.Create(url));
            hwreq.UserAgent = "Monazilla";
            WebResponse res = hwreq.GetResponse();
            string dat = "";
            using(StreamReader sr = new StreamReader(res.GetResponseStream(), Encoding.GetEncoding("Shift-Jis"))) {
                dat = sr.ReadToEnd();
                sr.Close();
            }
            this.datView1.ShowDat(dat);
        }

        private void threadList1_KeyDown(object sender, KeyEventArgs e) {
            if(e.KeyCode != Keys.Enter) return;
            this.threadList1_Click(sender, null);
        }
    }
}